//////////////////////////////////////////////////////////
// Title:		drm3310.h								//
// Version:		v1.0									//
// Date:		12.08.2004								//
// Last Change:	15.08.2004								//
// Desc:		Nokia 3310 Lcd Ansteuerung				//
// Author:		Thomas Weger							//
// Compiler:	AVR-GCC: WinAVR-20040720				//
//////////////////////////////////////////////////////////

#ifndef DRM3310_H
#define DRM3310_H

// Lcd 
#define GLCD_PIXELX			84
#define GLCD_PIXELY			48
#define GLCD_CACHE_SIZE		((GLCD_PIXELX * GLCD_PIXELY) / 8)

// Lcd Port Settings
#define GLCD_SER_PORT		PORTD
#define GLCD_SER_DDR		DDRD
#define GLCD_SCLK			PD5
#define GLCD_MOSI			PD6
#define GLCD_SS				PD0

#define GLCD_CTRL_PORT		PORTB
#define GLCD_CTRL_DDR		DDRB
#define GLCD_DC				PB0
#define GLCD_CE_			PB1
#define GLCD_RES_			PB2

// Lcd Commands (normal Functionset)
#define GLCD_FUNCTIONSET	0x20
#define GLCD_SETXADDR		0x80
#define GLCD_SETYADDR		0x40
#define	GLCD_DISPLAYBLANK	0x08
#define	GLCD_DISPLAYFLUSH	0x09
#define	GLCD_DISPLAYNORMAL	0x0C
#define	GLCD_DISPLAYINVERT	0x0D

// Lcd Commands (extended Functionset)
#define GLCD_FUNCTIONSETEXT	0x21
#define GLCD_BIAS			0x13	// Bias 1:48
#define GLCD_TEMPCOEF		0x06	// TF = 2
#define GLCD_SETVOP			0x80

// Init 
void glcdn_InitDisplay(void);
void glcdn_WriteData(uint8_t myData);
void glcdn_WriteCommand(uint8_t myData);
void glcdn_spiSendByte(uint8_t myByte);
void glcdn_spiInit(void);
void glcdn_Delay(long ld);
void glcdn_ClearLcd(void);
void glcdn_SetCharAddrXY(uint8_t myX, uint8_t myY);					
void glcdn_PutStrXLine(uint8_t *data, uint8_t x, uint8_t line);
void glcdn_Contrast ( uint8_t contrast );							//0x00 to 0x7F
void glcdn_WriteCache(uint8_t x, uint8_t page, uint16_t size);
void glcdn_SetPixel(uint8_t dpX, uint8_t dpY, uint8_t mode);		// mode 0 = Clear, mode 1 = Draw
void glcdn_ShowImage(uint8_t image[]);
void glcdn_TestA(void);


// FASTLCD "IMAGE MODE"
static unsigned char __attribute__ ((progmem)) glcdNokia[] = {
0x40,0x40,0x40,0xFF,0x40,0x40,0xFF,0x40,0x40,0xFF,0x40,0x40,0xFF,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xFF,0x40,0x40,0xFF,0x40,0x40,0xFF,0x40,
0x40,0xFF,0x40,0x40,0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,
0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0xF0,0x70,0xE0,0x80,0x00,0x00,
0x00,0xF0,0xF0,0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0xF8,0xF8,
0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0xB0,0xB0,0x00,0x00,0x80,0x80,0x80,0x80,
0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,
0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
0x01,0x07,0x1E,0x78,0xE0,0xFF,0xFF,0x00,0x7E,0xFF,0xC3,0x81,0x81,0x81,0xC3,0xFF,
0x7E,0x00,0xFF,0xFF,0x08,0x3C,0x77,0xE3,0xC1,0x80,0x00,0x00,0xFF,0xFF,0x00,0xF0,
0xF9,0x9D,0x8D,0x8D,0x8D,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,
0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x01,0x01,0x00,0x00,0x20,0x30,0x10,0x11,0x31,0xF1,0xE0,0x00,0x00,0x21,0x31,
0x11,0x11,0x31,0xF0,0xE0,0x00,0x01,0x41,0x40,0xF0,0xF0,0x00,0x01,0x01,0x01,0xC0,
0xE1,0x31,0x10,0x10,0x31,0xE1,0xC1,0x01,0x00,0x01,0x01,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,
0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xC0,0x82,0x82,0xC7,0x7D,0x38,
0x00,0x00,0x40,0xC0,0x82,0x82,0xC7,0x7D,0x38,0x00,0x00,0x80,0x80,0xFF,0xFF,0x80,
0x80,0x00,0x00,0x3F,0x7F,0xC0,0x80,0x80,0xC0,0x7F,0x3F,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0xFF,0x00,
0x00,0xFF,0x00,0x00,0x04,0x04,0x04,0xFF,0x04,0x04,0xFF,0x04,0x04,0xFF,0x04,0x04,
0xFF,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,
0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0xFC,0x04,
0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,
0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0xFF,0x04,0x04,0xFF,
0x04,0x04,0xFF,0x04,0x04,0xFF,0x04,0x04
};



// FASTLCD "IMAGE MODE"
static unsigned char __attribute__ ((progmem)) glcdTarja[] = {
0xFF,0xBB,0xFF,0xD5,0xFF,0xB7,0xFF,0xB5,0x6F,0xFF,0x6B,0xFF,0xDD,0xFF,0xDD,0xBB,
0x77,0xDD,0x77,0xDD,0xF7,0x2D,0xEB,0x5E,0x75,0xCF,0x3A,0xE5,0xAE,0x39,0xE7,0xA8,
0xDF,0xB9,0x66,0x2D,0xAB,0x1A,0x15,0x2E,0x1D,0x1B,0x1E,0x3D,0x35,0x7F,0x7A,0xE7,
0xDD,0x37,0x5D,0xEF,0xFA,0xAF,0x7D,0xD3,0xBE,0xA5,0x5F,0xBA,0x65,0xBF,0xC0,0x3F,
0xEA,0x99,0xF7,0x24,0x5D,0xFB,0xA6,0xBD,0xEB,0x5D,0xF7,0xBE,0x7B,0xE7,0xBD,0xFF,
0xD7,0x7D,0xEF,0xFD,0xF7,0xFD,0xAF,0xFD,0x7F,0xD5,0xFF,0x6F,0xFD,0xDF,0xFB,0xB6,
0x6F,0xDB,0xBE,0xEB,0x9F,0xF9,0x27,0xFC,0x27,0xEA,0xAD,0x5B,0xB6,0x4D,0x7A,0xD5,
0x2B,0x0E,0xA3,0x02,0x11,0xC4,0xB0,0xE4,0x90,0xA9,0x00,0xA0,0x25,0x00,0x4A,0xA0,
0x0A,0xC1,0xA8,0x83,0xFF,0xED,0xFE,0xBA,0xF3,0xAF,0x7E,0xF9,0xD7,0xAC,0xCB,0xBE,
0xB9,0xE6,0x5D,0xEA,0x54,0xBB,0xE6,0x9B,0xF5,0x36,0xED,0x56,0x7F,0xED,0xFB,0xAF,
0xFB,0xAE,0xFB,0xAD,0xFF,0x5B,0xF6,0xDF,0x07,0x0E,0xDF,0x9F,0x0B,0x4E,0x0F,0xCB,
0x8E,0x25,0xC7,0x8D,0x9B,0x16,0x2D,0x32,0xCE,0xBB,0xAA,0x5D,0x72,0xC5,0xBE,0xA3,
0x3E,0x41,0x9F,0x0B,0xAE,0x02,0x14,0x41,0x02,0x07,0x0E,0x4F,0x19,0x1D,0x99,0x0D,
0x8B,0x1C,0x03,0xDA,0x02,0x24,0x4A,0xAA,0xFB,0xFF,0xFF,0xF7,0xFF,0xFF,0x7F,0xF7,
0xFE,0xFF,0xFE,0xED,0x7E,0xFF,0xEB,0xFF,0xBF,0xFA,0xFE,0xE5,0xBD,0xD7,0xED,0x5F,
0xFA,0x57,0xFE,0xBB,0xE6,0x3B,0xDE,0x75,0xEF,0x5D,0xF6,0xDF,0xF5,0xFF,0xBE,0xFA,
0xED,0xD4,0x00,0xE9,0x80,0x72,0xC0,0x30,0xE5,0x19,0xF0,0xEC,0x20,0xF8,0x61,0xE1,
0x6A,0xF3,0x42,0xED,0x4B,0xE5,0xE7,0x62,0xC3,0xC6,0x2A,0x41,0xA0,0x2A,0xA0,0x5D,
0xF0,0x5A,0xF4,0xEA,0xBC,0x6A,0xFA,0x6C,0xFB,0xF6,0xBD,0xFE,0xFF,0xFF,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,0xFE,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xFF,0xFB,
0xFE,0xF5,0xDF,0xB5,0xEF,0x5D,0xF6,0x5F,0xF5,0x5F,0xF5,0xCF,0x3D,0xEB,0xBE,0x6D,
0xBD,0x57,0x7D,0xEF,0xD3,0xED,0xD3,0xDE,0xB5,0x1D,0x65,0xBB,0xC6,0xBD,0x2B,0xFF,
0xDA,0xB7,0x6D,0xB7,0xCB,0xB5,0xFF,0x2B,0x7F,0xBE,0x97,0x5F,0xCF,0x1F,0x47,0x52,
0x84,0x2A,0x48,0x55,0xAB,0x6A,0x95,0x6D,0xD9,0x77,0xED,0xFB,0xF6,0xFD,0xEF,0xFF,
0xFF,0xFF,0xF7,0xFF,0xFF,0xFF,0xFD,0xFF,0xFF,0xFF,0xFF,0xBE,0xFF,0xFF,0xFF,0xEE,
0xFF,0xFF,0xFF,0xFE,0xFF,0xF7,0xBE,0xED,0xDB,0x35,0xEF,0x5D,0x7A,0xD7,0x7D,0xAB,
0xF5,0xAE,0x35,0xEF,0xBB,0xA5,0xDF,0x32,0xDF,0x97,0x25,0x0B,0x45,0x9B,0x05,0x1E,
0xC5,0x1D,0x7F,0x96,0x6F,0xDB,0x5C,0xF3,0x24,0xFF,0x95,0xEF,0xF3,0xB3,0xD1,0x72,
0xD0,0xB5,0x68,0xDA,0x7C,0xD9,0xB7,0x6C,0xDB,0xBE,0xED,0x3B,0xEF,0xBD,0xEF,0xBD,
0x6F,0xFF,0xDF,0xFF,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xBF,0xFF,0xFF,0x7F,0xFB,0xEF,
0xFF,0x5E,0xE7,0xBF,0xF7,0x5F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFA,0x57,0xED,0x3B,0xEF,
0xDA,0xB7,0xDB,0xB6,0x6D,0xBB,0xE6,0x5D
};


static unsigned char __attribute__ ((progmem)) Font5x7[] = {
	0x00, 0x00, 0x00, 0x00, 0x00,// (space)
	0x00, 0x00, 0x5F, 0x00, 0x00,// !
	0x00, 0x07, 0x00, 0x07, 0x00,// "
	0x14, 0x7F, 0x14, 0x7F, 0x14,// #
	0x24, 0x2A, 0x7F, 0x2A, 0x12,// $
	0x23, 0x13, 0x08, 0x64, 0x62,// %
	0x36, 0x49, 0x55, 0x22, 0x50,// &
	0x00, 0x05, 0x03, 0x00, 0x00,// '
	0x00, 0x1C, 0x22, 0x41, 0x00,// (
	0x00, 0x41, 0x22, 0x1C, 0x00,// )
	0x08, 0x2A, 0x1C, 0x2A, 0x08,// *
	0x08, 0x08, 0x3E, 0x08, 0x08,// +
	0x00, 0x50, 0x30, 0x00, 0x00,// ,
	0x08, 0x08, 0x08, 0x08, 0x08,// -
	0x00, 0x60, 0x60, 0x00, 0x00,// .
	0x20, 0x10, 0x08, 0x04, 0x02,// /
	0x3E, 0x51, 0x49, 0x45, 0x3E,// 0
	0x00, 0x42, 0x7F, 0x40, 0x00,// 1
	0x42, 0x61, 0x51, 0x49, 0x46,// 2
	0x21, 0x41, 0x45, 0x4B, 0x31,// 3
	0x18, 0x14, 0x12, 0x7F, 0x10,// 4
	0x27, 0x45, 0x45, 0x45, 0x39,// 5
	0x3C, 0x4A, 0x49, 0x49, 0x30,// 6
	0x01, 0x71, 0x09, 0x05, 0x03,// 7
	0x36, 0x49, 0x49, 0x49, 0x36,// 8
	0x06, 0x49, 0x49, 0x29, 0x1E,// 9
	0x00, 0x36, 0x36, 0x00, 0x00,// :
	0x00, 0x56, 0x36, 0x00, 0x00,// ;
	0x00, 0x08, 0x14, 0x22, 0x41,// <
	0x14, 0x14, 0x14, 0x14, 0x14,// =
	0x41, 0x22, 0x14, 0x08, 0x00,// >
	0x02, 0x01, 0x51, 0x09, 0x06,// ?
	0x32, 0x49, 0x79, 0x41, 0x3E,// @
	0x7E, 0x11, 0x11, 0x11, 0x7E,// A
	0x7F, 0x49, 0x49, 0x49, 0x36,// B
	0x3E, 0x41, 0x41, 0x41, 0x22,// C
	0x7F, 0x41, 0x41, 0x22, 0x1C,// D
	0x7F, 0x49, 0x49, 0x49, 0x41,// E
	0x7F, 0x09, 0x09, 0x01, 0x01,// F
	0x3E, 0x41, 0x41, 0x51, 0x32,// G
	0x7F, 0x08, 0x08, 0x08, 0x7F,// H
	0x00, 0x41, 0x7F, 0x41, 0x00,// I
	0x20, 0x40, 0x41, 0x3F, 0x01,// J
	0x7F, 0x08, 0x14, 0x22, 0x41,// K
	0x7F, 0x40, 0x40, 0x40, 0x40,// L
	0x7F, 0x02, 0x04, 0x02, 0x7F,// M
	0x7F, 0x04, 0x08, 0x10, 0x7F,// N
	0x3E, 0x41, 0x41, 0x41, 0x3E,// O
	0x7F, 0x09, 0x09, 0x09, 0x06,// P
	0x3E, 0x41, 0x51, 0x21, 0x5E,// Q
	0x7F, 0x09, 0x19, 0x29, 0x46,// R
	0x46, 0x49, 0x49, 0x49, 0x31,// S
	0x01, 0x01, 0x7F, 0x01, 0x01,// T
	0x3F, 0x40, 0x40, 0x40, 0x3F,// U
	0x1F, 0x20, 0x40, 0x20, 0x1F,// V
	0x7F, 0x20, 0x18, 0x20, 0x7F,// W
	0x63, 0x14, 0x08, 0x14, 0x63,// X
	0x03, 0x04, 0x78, 0x04, 0x03,// Y
	0x61, 0x51, 0x49, 0x45, 0x43,// Z
	0x00, 0x00, 0x7F, 0x41, 0x41,// [
	0x02, 0x04, 0x08, 0x10, 0x20,// "\"
	0x41, 0x41, 0x7F, 0x00, 0x00,// ]
	0x04, 0x02, 0x01, 0x02, 0x04,// ^
	0x40, 0x40, 0x40, 0x40, 0x40,// _
	0x00, 0x01, 0x02, 0x04, 0x00,// `
	0x20, 0x54, 0x54, 0x54, 0x78,// a
	0x7F, 0x48, 0x44, 0x44, 0x38,// b
	0x38, 0x44, 0x44, 0x44, 0x20,// c
	0x38, 0x44, 0x44, 0x48, 0x7F,// d
	0x38, 0x54, 0x54, 0x54, 0x18,// e
	0x08, 0x7E, 0x09, 0x01, 0x02,// f
	0x08, 0x14, 0x54, 0x54, 0x3C,// g
	0x7F, 0x08, 0x04, 0x04, 0x78,// h
	0x00, 0x44, 0x7D, 0x40, 0x00,// i
	0x20, 0x40, 0x44, 0x3D, 0x00,// j
	0x00, 0x7F, 0x10, 0x28, 0x44,// k
	0x00, 0x41, 0x7F, 0x40, 0x00,// l
	0x7C, 0x04, 0x18, 0x04, 0x78,// m
	0x7C, 0x08, 0x04, 0x04, 0x78,// n
	0x38, 0x44, 0x44, 0x44, 0x38,// o
	0x7C, 0x14, 0x14, 0x14, 0x08,// p
	0x08, 0x14, 0x14, 0x18, 0x7C,// q
	0x7C, 0x08, 0x04, 0x04, 0x08,// r
	0x48, 0x54, 0x54, 0x54, 0x20,// s
	0x04, 0x3F, 0x44, 0x40, 0x20,// t
	0x3C, 0x40, 0x40, 0x20, 0x7C,// u
	0x1C, 0x20, 0x40, 0x20, 0x1C,// v
	0x3C, 0x40, 0x30, 0x40, 0x3C,// w
	0x44, 0x28, 0x10, 0x28, 0x44,// x
	0x0C, 0x50, 0x50, 0x50, 0x3C,// y
	0x44, 0x64, 0x54, 0x4C, 0x44,// z
	0x00, 0x08, 0x36, 0x41, 0x00,// {
	0x00, 0x00, 0x7F, 0x00, 0x00,// |
	0x00, 0x41, 0x36, 0x08, 0x00,// }
	0x08, 0x08, 0x2A, 0x1C, 0x08,// ->
	0x08, 0x1C, 0x2A, 0x08, 0x08 // <-
};

#endif
